package com.bbva.pzic.claims.facade.v0.dto;

import com.bbva.pzic.claims.canonic.Bank;
import com.bbva.pzic.claims.canonic.ClaimType;
import com.bbva.pzic.routine.commons.utils.BooleanAdapter;
import com.bbva.pzic.routine.commons.utils.CustomCalendarAdapter;

import javax.xml.bind.annotation.*;
import javax.xml.bind.annotation.adapters.XmlJavaTypeAdapter;
import java.io.Serializable;
import java.util.Calendar;
import java.util.List;

/**
 * @author Entelgy
 */
@XmlRootElement(name = "productClaims", namespace = "urn:com:bbva:pzic:claims:facade:v0:dto")
@XmlType(name = "productClaims", namespace = "urn:com:bbva:pzic:claims:facade:v0:dto")
@XmlAccessorType(XmlAccessType.FIELD)
public class ProductClaims implements Serializable {

    private static final long serialVersionUID = 1L;
    /**
     * Unique identifier of the claim.
     */
    private String id;
    /**
     * Claim number.
     */
    private String number;
    /**
     * String based on ISO-8601 for specifying the registration of the claim.
     */
    @XmlJavaTypeAdapter(CustomCalendarAdapter.class)
    @XmlSchemaType(name="dateTime")
    private Calendar creationDate;
    /**
     * Indicates whether the petitioner represents a legal person or a natural person
     */
    private PersonType personType;
    /**
     * Indicates whether the petitioner represents a legal person or a natural person
     */
    private ProductSearch product;
    /**
     * Product associated to the claim.
     */
    private ClaimType claimType;
    /**
     * Reason associated with the product, for which the petition or claim is made.
     */
    private ReasonSearch reason;
    /**
     * Resolution of the claim analysis.
     */
    private ResolutionSearch resolution;
    /**
     * Current status of the claim or request.
     */
    private StatusSearch status;
    /**
     * Required for product claims. in claims generated by a company must indicate the representative indicating the type of petitioner AUTHORIZED.
     */
    private List<PetitionersSearch> petitioners;
    /**
     * Documents for product claims.
     */
    private List<Document> documents;
    /**
     * Tracking for product claims.
     */
    private List<Tracking> tracking;
    /**
     * Product contract.
     */
    private Contract contract;
    /**
     * Claim amount by the petitioner.
     */
    private Amount claimAmount;
    /**
     * Delivery of the submitted claim document to the petitioner.
     */
    private Delivery delivery;
    /**
     * It’s the channel in which the petitioner submits the claim.
     */
    private Channel channel;

    /**
     * Geographical location from where the claim is registered.
     * This code represents the three levels of the territorial subdivision in Perú.
     */
    private Geolocation geolocation;
    /**
     * ATM where the issue, related to the claim, was held.
     */
    private Atm atm;
    /**
     * Bank where the issue, related to the claim, is originated.
     */
    private Bank bank;
    /**
     * Petition asked for the person who makes the claim.
     */
    private Petition petition;
    /**
     * Claim priority.
     */
    private Priority priority;
    /**
     * String based on ISO-8601 for specifying the claim enrollment date.
     */
    @XmlJavaTypeAdapter(CustomCalendarAdapter.class)
    @XmlSchemaType(name = "dateTime")
    private Calendar enrollmentDate;
    /**
     * String based on ISO-8601 for specifying the claim end date.
     */
    @XmlJavaTypeAdapter(CustomCalendarAdapter.class)
    @XmlSchemaType(name = "dateTime")
    private Calendar endDate;
    /**
     * Claim category.
     */
    private CategorySearch category;
    /**
     * Claim additional information. Complementary detail about the case.
     */
    private String additionalInformation;
    /**
     * Bank application where the claim is registered.
     */
    private OriginApplication originApplication;
    /**
     * Claim that was previously registered in order to request the same petition that
     * the current claim and associated to the same product.
     */
    private PredecessorClaimSearch predecessorClaim;
    /**
     * It indicates if the person accepts the online refund.
     */
    @XmlJavaTypeAdapter(BooleanAdapter.class)
    private String isOnlineRefundFlow;
    /**
     * External code that represents a previous online attention before to register the claim.
     */
    private String previousAttentionCode;
    /**
     * Additional claims related to the principal claim. It applies when the principal claim is multiple.
     */
    private List<AdditionalClaim> additionalClaims;

    @XmlJavaTypeAdapter(CustomCalendarAdapter.class)
    @XmlSchemaType(name = "dateTime")
    private Calendar issueDate;

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getNumber() {
        return number;
    }

    public void setNumber(String number) {
        this.number = number;
    }

    public Calendar getCreationDate() {
        return creationDate;
    }

    public void setCreationDate(Calendar creationDate) {
        this.creationDate = creationDate;
    }

    public PersonType getPersonType() {
        return personType;
    }

    public void setPersonType(PersonType personType) {
        this.personType = personType;
    }

    public ProductSearch getProduct() {
        return product;
    }

    public void setProduct(ProductSearch product) {
        this.product = product;
    }

    public ClaimType getClaimType() {
        return claimType;
    }

    public void setClaimType(ClaimType claimType) {
        this.claimType = claimType;
    }

    public ReasonSearch getReason() {
        return reason;
    }

    public void setReason(ReasonSearch reason) {
        this.reason = reason;
    }

    public ResolutionSearch getResolution() {
        return resolution;
    }

    public void setResolution(ResolutionSearch resolution) {
        this.resolution = resolution;
    }

    public StatusSearch getStatus() {
        return status;
    }

    public void setStatus(StatusSearch status) {
        this.status = status;
    }

    public List<PetitionersSearch> getPetitioners() {
        return petitioners;
    }

    public void setPetitioners(List<PetitionersSearch> petitioners) {
        this.petitioners = petitioners;
    }

    public List<Document> getDocuments() {
        return documents;
    }

    public void setDocuments(List<Document> documents) {
        this.documents = documents;
    }

    public List<Tracking> getTracking() {
        return tracking;
    }

    public void setTracking(List<Tracking> tracking) {
        this.tracking = tracking;
    }

    public Contract getContract() {
        return contract;
    }

    public void setContract(Contract contract) {
        this.contract = contract;
    }

    public Amount getClaimAmount() {
        return claimAmount;
    }

    public void setClaimAmount(Amount claimAmount) {
        this.claimAmount = claimAmount;
    }

    public Delivery getDelivery() {
        return delivery;
    }

    public void setDelivery(Delivery delivery) {
        this.delivery = delivery;
    }

    public Channel getChannel() {
        return channel;
    }

    public void setChannel(Channel channel) {
        this.channel = channel;
    }

    public Geolocation getGeolocation() {
        return geolocation;
    }

    public void setGeolocation(Geolocation geolocation) {
        this.geolocation = geolocation;
    }

    public Atm getAtm() {
        return atm;
    }

    public void setAtm(Atm atm) {
        this.atm = atm;
    }

    public Bank getBank() {
        return bank;
    }

    public void setBank(Bank bank) {
        this.bank = bank;
    }

    public Petition getPetition() {
        return petition;
    }

    public void setPetition(Petition petition) {
        this.petition = petition;
    }

    public Priority getPriority() {
        return priority;
    }

    public void setPriority(Priority priority) {
        this.priority = priority;
    }

    public Calendar getEnrollmentDate() {
        return enrollmentDate;
    }

    public void setEnrollmentDate(Calendar enrollmentDate) {
        this.enrollmentDate = enrollmentDate;
    }

    public Calendar getEndDate() {
        return endDate;
    }

    public void setEndDate(Calendar endDate) {
        this.endDate = endDate;
    }

    public CategorySearch getCategory() {
        return category;
    }

    public void setCategory(CategorySearch category) {
        this.category = category;
    }

    public String getAdditionalInformation() {
        return additionalInformation;
    }

    public void setAdditionalInformation(String additionalInformation) {
        this.additionalInformation = additionalInformation;
    }

    public OriginApplication getOriginApplication() {
        return originApplication;
    }

    public void setOriginApplication(OriginApplication originApplication) {
        this.originApplication = originApplication;
    }

    public PredecessorClaimSearch getPredecessorClaim() {
        return predecessorClaim;
    }

    public void setPredecessorClaim(PredecessorClaimSearch predecessorClaim) {
        this.predecessorClaim = predecessorClaim;
    }

    public String getIsOnlineRefundFlow() {
        return isOnlineRefundFlow;
    }

    public void setIsOnlineRefundFlow(String isOnlineRefundFlow) {
        this.isOnlineRefundFlow = isOnlineRefundFlow;
    }

    public String getPreviousAttentionCode() {
        return previousAttentionCode;
    }

    public void setPreviousAttentionCode(String previousAttentionCode) {
        this.previousAttentionCode = previousAttentionCode;
    }

    public List<AdditionalClaim> getAdditionalClaims() {
        return additionalClaims;
    }

    public void setAdditionalClaims(List<AdditionalClaim> additionalClaims) {
        this.additionalClaims = additionalClaims;
    }

    public Calendar getIssueDate() {
        return issueDate;
    }

    public void setIssueDate(Calendar issueDate) {
        this.issueDate = issueDate;
    }
}
